// Using both AWT and Swing because AWT apparently doesn't allow setting a default button in a dialog box and Swing's
// file open dialog boxes don't look anywhere near native (at least on OS X).
import java.awt.Container;
import java.awt.Dimension;
import java.awt.DisplayMode;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.FileDialog;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JSpinner.NumberEditor;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.text.NumberFormatter;

import java.io.File;
import java.io.IOException;
import java.util.List;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.UnsupportedAudioFileException;



class Tempest_in_a_Java_Pot{

	private static boolean should_Quit=false;

	// Settings that are specified by the user.
	private static String audio_File_Path="";
	private static int AM_Frequency_To_Transmit_On=1000*1000; // Defined in Hz, not kHZ
	private static int audio_Transmission_Amplification=100; // Percentage of normal
	private static int algorithm_To_Use_For_Generating_Transmission_Frame=1;
	private static int screen_Width=-1, screen_Height=-1, refresh_Rate=-1;


	public static void main(String[] args){

		java.lang.Runtime.getRuntime().addShutdownHook(new Thread(){
			@Override public void run(){
				should_Quit=true;


				// TODO: Shut down more elegantly.

				// This is ugly but seems to work well. JOGL doesn't seem to respond too well to using the Quit command
				// in the application menu on OS X, especially when changing resolutions or using an animator
				// apparently.
				java.lang.Runtime.getRuntime().halt(0);
			}
		});


		while(!should_Quit){

			final JDialog tempest_in_a_Java_Pot_Settings_Dialog=
			  new JDialog((JFrame)null, "Tempest in a Java Pot Settings", true);
			final Container tempest_in_a_Java_Pot_Settings_Dialog_Content_Pane=
			  tempest_in_a_Java_Pot_Settings_Dialog.getContentPane();
			tempest_in_a_Java_Pot_Settings_Dialog_Content_Pane.setLayout(
			  new BoxLayout(tempest_in_a_Java_Pot_Settings_Dialog_Content_Pane, BoxLayout.Y_AXIS));



			final JButton run_In_Window_Button=new JButton("Run in Window");
			final JButton run_Full_Screen_Button=new JButton("Run Full Screen");
			run_In_Window_Button.setEnabled(false);
			run_Full_Screen_Button.setEnabled(false);



			final JPanel audio_File_Panel=new JPanel();
			audio_File_Panel.setLayout(new BoxLayout(audio_File_Panel, BoxLayout.X_AXIS));
			audio_File_Panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

			final JLabel audio_File_Path_Label=new JLabel("Audio file path:");
			audio_File_Panel.add(audio_File_Path_Label);

			final JTextField audio_File_Path_Text_Field=new JTextField(50);
			audio_File_Path_Text_Field.getDocument().addDocumentListener(new DocumentListener(){
				@Override public void changedUpdate(DocumentEvent event){update_Audio_File_Path();}
				@Override public void insertUpdate(DocumentEvent event){update_Audio_File_Path();}
				@Override public void removeUpdate(DocumentEvent event){update_Audio_File_Path();}

				private void update_Audio_File_Path(){
					audio_File_Path=audio_File_Path_Text_Field.getText();

					final File audio_File=new File(audio_File_Path);
					if(audio_File.isFile()){
						try{
							AudioSystem.getAudioFileFormat(audio_File);
						}catch(UnsupportedAudioFileException exception){
							run_In_Window_Button.setEnabled(false);
							run_Full_Screen_Button.setEnabled(false);
							JOptionPane.showMessageDialog(tempest_in_a_Java_Pot_Settings_Dialog,
							  "The selected file is not an audio file type supported by this system.",
							  "Unsupported file type", JOptionPane.ERROR_MESSAGE);
							return;
						}catch(IOException exception){
							run_In_Window_Button.setEnabled(false);
							run_Full_Screen_Button.setEnabled(false);
							JOptionPane.showMessageDialog(tempest_in_a_Java_Pot_Settings_Dialog,
							  "The selected file could not be read.", "Read error", JOptionPane.ERROR_MESSAGE);
							return;
						}

						run_In_Window_Button.setEnabled(true);
						run_Full_Screen_Button.setEnabled(true);
					}else{
						run_In_Window_Button.setEnabled(false);
						run_Full_Screen_Button.setEnabled(false);
					}
				}
			});
			audio_File_Path_Text_Field.setText(audio_File_Path);
			audio_File_Panel.add(audio_File_Path_Text_Field);

			final JButton select_Audio_File_Button=new JButton("Browse...");
			select_Audio_File_Button.addActionListener(new ActionListener(){
				@Override public void actionPerformed(ActionEvent e){
					final FileDialog select_Audio_File_Dialog=
					  new FileDialog(tempest_in_a_Java_Pot_Settings_Dialog, "Select Audio File");
					select_Audio_File_Dialog.setVisible(true);
					if(select_Audio_File_Dialog.getFile()!=null){
						if(select_Audio_File_Dialog.getDirectory()==null)
							audio_File_Path_Text_Field.setText(select_Audio_File_Dialog.getFile());
						else
							audio_File_Path_Text_Field.setText(select_Audio_File_Dialog.getDirectory()
							  + select_Audio_File_Dialog.getFile());
					}
				}
			});
			audio_File_Panel.add(select_Audio_File_Button);

			tempest_in_a_Java_Pot_Settings_Dialog_Content_Pane.add(audio_File_Panel);



			final JPanel AM_Frequency_And_Audio_Amplification_Panel=new JPanel();
			AM_Frequency_And_Audio_Amplification_Panel.setLayout(
			  new BoxLayout(AM_Frequency_And_Audio_Amplification_Panel, BoxLayout.X_AXIS));
			AM_Frequency_And_Audio_Amplification_Panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

			final JLabel AM_Frequency_Label=new JLabel("AM frequency to transmit on (kHz):");
			AM_Frequency_And_Audio_Amplification_Panel.add(AM_Frequency_Label);

			final JSpinner AM_Frequency_Spinner=new JSpinner(
			  new SpinnerNumberModel(AM_Frequency_To_Transmit_On/1000, 1, 9999,1));
			NumberEditor AM_Frequency_Spinner_Editor=new JSpinner.NumberEditor(AM_Frequency_Spinner, "#");
			((NumberFormatter)AM_Frequency_Spinner_Editor.getTextField().getFormatter()).setAllowsInvalid(false);
			AM_Frequency_Spinner_Editor.getTextField().getDocument().addDocumentListener(new DocumentListener(){
				@Override public void changedUpdate(DocumentEvent event){update_AM_Frequency_To_Transmit_On();}
				@Override public void insertUpdate(DocumentEvent event){update_AM_Frequency_To_Transmit_On();}
				@Override public void removeUpdate(DocumentEvent event){update_AM_Frequency_To_Transmit_On();}

				private void update_AM_Frequency_To_Transmit_On(){
					AM_Frequency_To_Transmit_On=((int)AM_Frequency_Spinner.getValue())*1000;
				}
			});
			AM_Frequency_Spinner.setEditor(AM_Frequency_Spinner_Editor);
			AM_Frequency_Spinner.setMaximumSize(AM_Frequency_Spinner.getPreferredSize());
			AM_Frequency_And_Audio_Amplification_Panel.add(AM_Frequency_Spinner);

			AM_Frequency_And_Audio_Amplification_Panel.add(Box.createRigidArea(new Dimension(50, 0)));

			final JLabel audio_Transmission_Amplification_Label=new JLabel("Audio transmission amplification (%):");
			AM_Frequency_And_Audio_Amplification_Panel.add(audio_Transmission_Amplification_Label);

			final JSpinner audio_Transmission_Amplification_Spinner=
			  new JSpinner(new SpinnerNumberModel(audio_Transmission_Amplification, 1, 400, 1));
			final NumberEditor audio_Transmission_Amplification_Spinner_Editor=
			  new JSpinner.NumberEditor(audio_Transmission_Amplification_Spinner, "#");
			((NumberFormatter)audio_Transmission_Amplification_Spinner_Editor.getTextField().getFormatter()).
			  setAllowsInvalid(false);
			audio_Transmission_Amplification_Spinner_Editor.getTextField().getDocument().addDocumentListener(
			  new DocumentListener(){
				@Override public void changedUpdate(DocumentEvent event){update_Audio_Transmission_Amplification();}
				@Override public void insertUpdate(DocumentEvent event){update_Audio_Transmission_Amplification();}
				@Override public void removeUpdate(DocumentEvent event){update_Audio_Transmission_Amplification();}

				private void update_Audio_Transmission_Amplification(){
					audio_Transmission_Amplification=(int)audio_Transmission_Amplification_Spinner.getValue();
				}
			});
			audio_Transmission_Amplification_Spinner.setEditor(audio_Transmission_Amplification_Spinner_Editor);
			audio_Transmission_Amplification_Spinner.setMaximumSize(
			  audio_Transmission_Amplification_Spinner.getPreferredSize());
			AM_Frequency_And_Audio_Amplification_Panel.add(audio_Transmission_Amplification_Spinner);

			AM_Frequency_And_Audio_Amplification_Panel.add(Box.createHorizontalGlue());

			tempest_in_a_Java_Pot_Settings_Dialog_Content_Pane.add(AM_Frequency_And_Audio_Amplification_Panel);



			final JPanel transmission_Algorithm_Panel=new JPanel();
			transmission_Algorithm_Panel.setLayout(new BoxLayout(transmission_Algorithm_Panel, BoxLayout.X_AXIS));
			transmission_Algorithm_Panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

			final JLabel transmission_Algorithm_Label=new JLabel("Algorithm to use for generating transmission frame:");
			transmission_Algorithm_Panel.add(transmission_Algorithm_Label);

			final JComboBox<String> transmission_Algorithm_ComboBox=new JComboBox<String>();
			transmission_Algorithm_ComboBox.addItem("Sine wave AM carrier x Audio waveform plus Offset");
			transmission_Algorithm_ComboBox.addItem("Sine wave AM carrier x Audio waveform plus Offset (Faster but " +
			  "less precise)");
			transmission_Algorithm_ComboBox.addItem("Square wave AM carrier x Audio waveform plus Offset");
			transmission_Algorithm_ComboBox.addItem("Half sine wave AM carrier x Audio waveform");
			transmission_Algorithm_ComboBox.addItem("Offset sine wave AM carrier x Audio waveform");
			transmission_Algorithm_ComboBox.addItem("Offset square wave AM carrier x Audio waveform");
			transmission_Algorithm_ComboBox.addItem("Audio waveform");
			transmission_Algorithm_ComboBox.setSelectedIndex(algorithm_To_Use_For_Generating_Transmission_Frame);
			transmission_Algorithm_ComboBox.addActionListener(new ActionListener(){
				@Override public void actionPerformed(ActionEvent e){
					algorithm_To_Use_For_Generating_Transmission_Frame=
					  transmission_Algorithm_ComboBox.getSelectedIndex();
				}
			});
			transmission_Algorithm_ComboBox.setMaximumSize(transmission_Algorithm_ComboBox.getPreferredSize());
			transmission_Algorithm_Panel.add(transmission_Algorithm_ComboBox);

			transmission_Algorithm_Panel.add(Box.createHorizontalGlue());

			tempest_in_a_Java_Pot_Settings_Dialog_Content_Pane.add(transmission_Algorithm_Panel);



			final JPanel display_Mode_Panel=new JPanel();
			display_Mode_Panel.setLayout(new BoxLayout(display_Mode_Panel, BoxLayout.X_AXIS));
			display_Mode_Panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

			final JLabel display_Modes_Label=new JLabel("Resolution and refresh rate to use:");
			display_Mode_Panel.add(display_Modes_Label);

			final JComboBox<String> display_Modes_ComboBox=new JComboBox<String>();
			final List<DisplayMode> available_Display_Modes=Tempest_in_a_Java_Pot_Window.get_Available_Display_Modes();
			display_Modes_ComboBox.addItem("Current resolution and refresh rate");
			for(DisplayMode display_Mode : available_Display_Modes){
				String refresh_Rate_String=display_Mode.getRefreshRate()==DisplayMode.REFRESH_RATE_UNKNOWN ?
				  "Unknown refresh rate" : display_Mode.getRefreshRate() + " Hz";
				display_Modes_ComboBox.addItem(display_Mode.getWidth() + "x" + display_Mode.getHeight() + " @ " +
				  refresh_Rate_String);
				if(display_Mode.getWidth()==screen_Width && display_Mode.getHeight()==screen_Height &&
				  display_Mode.getRefreshRate()==refresh_Rate)
					display_Modes_ComboBox.setSelectedIndex(display_Modes_ComboBox.getItemCount()-1);
			}
			display_Modes_ComboBox.addActionListener(new ActionListener(){
				@Override public void actionPerformed(ActionEvent e){
					final int selected_Display_Mode_Index=display_Modes_ComboBox.getSelectedIndex();
					if(selected_Display_Mode_Index==0){
						screen_Width=screen_Height=refresh_Rate=-1;
					}else{
						screen_Width=available_Display_Modes.get(selected_Display_Mode_Index-1).getWidth();
						screen_Height=available_Display_Modes.get(selected_Display_Mode_Index-1).getHeight();
						refresh_Rate=available_Display_Modes.get(selected_Display_Mode_Index-1).getRefreshRate();
					}
				}
			});
			display_Modes_ComboBox.setMaximumSize(display_Modes_ComboBox.getPreferredSize());
			display_Mode_Panel.add(display_Modes_ComboBox);

			display_Mode_Panel.add(Box.createHorizontalGlue());

			tempest_in_a_Java_Pot_Settings_Dialog_Content_Pane.add(display_Mode_Panel);



			final JPanel quit_And_Run_Buttons_Panel=new JPanel();
			quit_And_Run_Buttons_Panel.setLayout(new BoxLayout(quit_And_Run_Buttons_Panel, BoxLayout.X_AXIS));
			quit_And_Run_Buttons_Panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

			quit_And_Run_Buttons_Panel.add(Box.createHorizontalGlue());

			final JButton quit_Button=new JButton("Quit");
			quit_Button.addActionListener(new ActionListener(){
				@Override public void actionPerformed(ActionEvent e){
					should_Quit=true;
					tempest_in_a_Java_Pot_Settings_Dialog.dispose();
				}
			});
			quit_And_Run_Buttons_Panel.add(quit_Button);

			run_In_Window_Button.addActionListener(new ActionListener(){
				@Override public void actionPerformed(ActionEvent e){
					tempest_in_a_Java_Pot_Settings_Dialog.dispose();
					Tempest_in_a_Java_Pot_Window tempest_in_a_Java_Pot_Window=new Tempest_in_a_Java_Pot_Window(
					  audio_File_Path, AM_Frequency_To_Transmit_On, audio_Transmission_Amplification,
					  algorithm_To_Use_For_Generating_Transmission_Frame, screen_Width, screen_Height, refresh_Rate, 0,
					  0);
					tempest_in_a_Java_Pot_Window.transmit_And_Play_Audio();
				}
			});
			quit_And_Run_Buttons_Panel.add(run_In_Window_Button);

			run_Full_Screen_Button.addActionListener(new ActionListener(){
				@Override public void actionPerformed(ActionEvent e){
					tempest_in_a_Java_Pot_Settings_Dialog.dispose();
					Tempest_in_a_Java_Pot_Window tempest_in_a_Java_Pot_Window=new Tempest_in_a_Java_Pot_Window(
					  audio_File_Path, AM_Frequency_To_Transmit_On, audio_Transmission_Amplification,
					  algorithm_To_Use_For_Generating_Transmission_Frame, screen_Width, screen_Height, refresh_Rate);
					tempest_in_a_Java_Pot_Window.transmit_And_Play_Audio();
				}
			});
			quit_And_Run_Buttons_Panel.add(run_Full_Screen_Button);
			tempest_in_a_Java_Pot_Settings_Dialog.getRootPane().setDefaultButton(run_Full_Screen_Button);

			tempest_in_a_Java_Pot_Settings_Dialog_Content_Pane.add(quit_And_Run_Buttons_Panel);



			tempest_in_a_Java_Pot_Settings_Dialog.pack();
			tempest_in_a_Java_Pot_Settings_Dialog.setResizable(false);
			tempest_in_a_Java_Pot_Settings_Dialog.setLocationRelativeTo(null);
			tempest_in_a_Java_Pot_Settings_Dialog.setVisible(true);
		}


		System.exit(0);
	}
}